﻿
#include <windows.h>
#include <winbase.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>

#define  __THE_DLL__
#include "DrvMercFR.h"

#pragma argsused

//#define password4

extern "C"
{

  int  __declspec(dllexport)  __stdcall Connect(
         unsigned char PortNum,
         unsigned short BaudRate,
         unsigned short Timeout,
         char     *psw);

  int  __declspec(dllexport) __stdcall Disconnect();


  int  __declspec(dllexport) __stdcall RegisterOper(
         int OperNum,
         char *OperName );
  int  __declspec(dllexport) __stdcall SendText(
         char *Text );


  int  __declspec(dllexport) __stdcall GetCurrOper(int *OperNum);

  int  __declspec(dllexport) __stdcall GetTaxNum(int *TaxNum);

  int  __declspec(dllexport) __stdcall GetTaxRate(
         int TaxIndex,
         int *TaxVal,
         char *Name);

  int  __declspec(dllexport) __stdcall OpenReceipt(int OperType);

  int  __declspec(dllexport) __stdcall  AddRecEntry(
         double Price,            // цена товара/услуги
         int Quantity,            // количество
         int  QuantityPrec,       // положение запятой
         double Sum,              // сумма (нафига правда не понял)
         int Depart,              // отдел
         int TaxIndex,            // налоговая ставка
         int Code,                // код
         char *Name               // наименование
  );

  int  __declspec(dllexport) __stdcall AddRecAdjust(double Sum,char *Text );

  int  __declspec(dllexport) __stdcall  AddPay(
         int PayType,
         double SumCash,
         double SumCashless
  );
  int  __declspec(dllexport) __stdcall CloseReceipt( int flag );

  int  __declspec(dllexport) __stdcall  GetLastDocNum(void) ;

  int  __declspec(dllexport) __stdcall Zreport( void );

  int  __declspec(dllexport) __stdcall Xreport( void );

  int  __declspec(dllexport) __stdcall GetExErrorCode( void );

  int  __declspec(dllexport) __stdcall QueryEcrIdent(
         char *ModelName,
         char *Manufacturer,
         char *FirmvareVersion
  );
  int  __declspec(dllexport) __stdcall QueryEcrIdentEx(
         char *ModelName,
         char *Manufacturer,
         char *FirmvareVersion,
         char *SN         
  );

  int  __declspec(dllexport) __stdcall QueryEcrDateTime( char  *pdatetime);
  int  __declspec(dllexport) __stdcall SynchronazeDateTime(void);
}

HANDLE         hCOM;               //
DCB            dcb;                // для работы с COM-портом
COMMTIMEOUTS   sTO;                //

unsigned char  NomIn=0,NomOut=0;       // текущ вх/вых номера кадров

unsigned char  password[16];       // пароль, переданный при Connect()
int            CurrMode;           // режим 0-гл. меню, 1-касс, -1 - неизв.
int            Operator;           // номер оператора
int            EX_Error;           // расширенный код ошибки


int                DocType;        // тип документа
DocOperationData   DocData[300];   // чековые операции
int                opcur;          // номер текущей операции
int LastDocNum;                    // номер последнегочека       

///////////////////////////////////////////////////////////////////////////////
// Служебные функции
///////////////////////////////////////////////////////////////////////////////
int SendKvit(int netno, unsigned char val);
int WaitKvit(int netno, unsigned char* value);
int WaitData(unsigned char *pdata, int maxlen, int *prxkol);
int WaitDataFromKKM(int netno, int maxlen, int *plen, unsigned char *pbuf);
int SendDataToKKM(int netno, int len, unsigned char  *pdata);
int GetStateKKM( int NetNo, int *pmode );
int ExitFromCashMode( void );

bool StrToBcd(
   unsigned char *pbcd,      // указатель на bcd-число
   int blen,                 // макс. длина bcd-числа в байтах
   unsigned char *pstr,      // указатель на строку
   int slen,                 // длина строки
   int point                 // требуемое положение дес точки
);

void IntToBcd( unsigned char *pbcd, int lenb);
unsigned int  BcdToInt( unsigned char *pbcd, int lenb);
void DoubleToBcd( unsigned char *pbcd, int lenbcd, double val );
double BcdToDouble( unsigned char *pbcd, int lenbcd );
int RecodeErrorKKM( int *err );



BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
    switch( fwdreason )
    {
        case DLL_PROCESS_ATTACH:
        {
           memset( password, '*', 10 );
           CurrMode=-1; DocType=-1; Operator=0;
           EX_Error = 0; opcur=0;
           hCOM=INVALID_HANDLE_VALUE;
           return true;
         }

        case DLL_THREAD_ATTACH:  return false;  // только один поток!


        case DLL_THREAD_DETACH:  break;

        case DLL_PROCESS_DETACH:
        {
          if(hCOM != INVALID_HANDLE_VALUE) {
             CloseHandle( hCOM );
             hCOM = INVALID_HANDLE_VALUE;
          }
          break;
        }
    }
    return true;  // Successful DLL_PROCESS_ATTACH.
}//<<< Eof DllMain() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


void LOG(char*s)
 {
  return;
  FILE *out = fopen("DrvMercFR.log", "a+t");
  if(out)
   {
    fprintf(out,"%d:%s\n",clock(),s);
    fclose(out);
   }
 }
int RecodeErrorKKM( int *err )
{
   int ecode;

   ecode = *err;

   switch( ecode )
   {
      case ENET_DOCOPEN: {
         if( err!=NULL ) *err=0;
         return ERR_REC_OPENED;
      }

      case ENET_BADOPER: {
         if( err!=NULL ) *err=EX_IAE_INVALID_OPER_TYPE;
         return  ERR_ECR_ERROR;
      }

      case ENET_ONLZERO: {
         if( err!=NULL ) *err=0;
         return ERR_BLANKING_NEEDED;
      }

      case ENET_NOTFIND: {
         if( err!=NULL ) *err=0;
         return ERR_VALUE_NOT_DEFINED;
      }

      case ENET_NOTAX: {
         if( err!=NULL ) *err=0;
         return ERR_VALUE_NOT_DEFINED;
      }

      case ENET_DOCOVR: {
         if( err!=NULL ) *err=EX_IAE_TOTAL_OVERFLOW;
         return  ERR_ECR_ERROR;
      }

      case ENET_TIMEOUT: {
         if( err!=NULL ) *err=0;
         return  ERR_NO_RESPONSE;
      }

      case ENET_BADPSW: {
         if( err!=NULL ) *err=0;
         return ERR_PASSWORD_NOT_VALID;
      }

      case ENET_ERDEPTH: {
         if( err!=NULL ) *err=EX_IAE_INVALID_DEPARTMENT;
         return ERR_INVALID_ARG;
      }

      case ENET_NOMONEY: {
         if( err!=NULL ) *err=0;
         return ERR_TO_LITTLE_CASHES;
      }

      default: {
         if( err!=NULL ) *err=0;
         return  ERR_ECR_ERROR;
      }
   }
}


int  GetStateKKM( int NetNo, int *pmode )
{
  int            res,i;
  unsigned char  txbuf[5], rxbuf[64];

  if( hCOM == INVALID_HANDLE_VALUE ) return ENET_NOT_CONN;

  txbuf[0]=2; txbuf[1]=1; txbuf[2]=0;   // вектор 2; функция 1; резерв=0;
  res = SendDataToKKM( NetNo, 3, &txbuf[0] );
  if( res==ENET_SUCCS ) //команда передана, ждем ответа
  {
    res=WaitDataFromKKM( NetNo, 256, &i, &rxbuf[0] );
    if( res==ENET_SUCCS )
    {
      if( rxbuf[2]==0 || rxbuf[2]==ENET_DOCOPEN )
      {
         *pmode = (int) rxbuf[3];
         if( rxbuf[2]==ENET_DOCOPEN ) { *pmode=1; }  // кас.реж. открыт чек
         return  ENET_SUCCS;
      }
      else return ENET_FORMAT; // вообще тут не могла прийти ошибка
    } return res;
  }
  else  {return ENET_TX_ERR;}  // ошибка передачи данных

}//<<< EOF  GetStateKKM()  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int ExitFromCashMode( void )
//////////////////////////////////////////////////////////////////////////////
//  Выход из кассового режима. Если есть открытый чек - аннулируется
//
//  Возвращает код(в формате драйвера):
//    SUCCESS         - вышли в главное меню :)
//    ERR_NO_RESPONSE - касса не отвечает
//    ERR_INTERNAL    - внутр ошибка драйвера
//
//////////////////////////////////////////////////////////////////////////////
{
 int           res,i,kol;
 unsigned char txbuf[32], rxbuf[256], ch;

 if( hCOM == INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;

 CurrMode = -1;  //глобально - режим неизвестен
 kol = 5;

 while( kol>0 )
 {
     txbuf[0]=2; txbuf[1]=2;  memset( &txbuf[2], 0, 17 );
     LOG(">>>>>ExitFromCashMode SendDataToKKM begin");
     res = SendDataToKKM( 1, 19, &txbuf[0] );
     LOG(">>>>>ExitFromCashMode SendDataToKKM end");     
     if( res==ENET_SUCCS ) //команда передана, ждем ответа
     {

        res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
        if( res==ENET_SUCCS )
        {
          if( rxbuf[2]==0 )
          {
             CurrMode = 0;
             LOG(">>>>>ExitFromCashMode SUCCESS");
             return SUCCESS;
          }
          else //--- касса вернула код ошибки
          {
            LOG(">>>>>ExitFromCashMode ECR ERROR");
             if( rxbuf[2]==ENET_DOCOPEN )
             {
                txbuf[0]=2; txbuf[1]=6; txbuf[3]=0;
                res = SendDataToKKM( 1, 3, &txbuf[0] );
                if( res==ENET_SUCCS )
                {
                   WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
//                   Sleep(5);
                   kol--;
                }
                else kol--;
             }
             else return ERR_ECR_ERROR;
          }
        }//--- ошибка при приеме ответа

        else
        {
           LOG(">>>>>ExitFromCashMode ERROR WaitDataFromKKM");
           EX_Error = res;
           return RecodeErrorKKM( &EX_Error );
        }
     }
     else
     {
       LOG(">>>>>ExitFromCashMode ERROR SEND");

        EX_Error = res;
        return RecodeErrorKKM( &EX_Error );
     }
 }//eof while( !fStop )

 return ERR_ECR_ERROR;
}


int SendDataToKKM(
/////////////////////////////////////////////////////////////////////////////
//
//  Отсылает данные на кассу с указанным сетевым номером
//
/////////////////////////////////////////////////////////////////////////////
   int            netno,      // сетевой номер ККМ
   int            len,        // длина блока данных
   unsigned char  *pdata)     // указатель на начало блока данных
{
  unsigned char  txbuf[600], nom, crc, flc;
  unsigned char  *dest;
  unsigned long  txkol,count,i;
  int            res;
  bool           fSucs;
  DWORD          Errors;

  nom = ((unsigned char)(netno/10))*16;
  nom = nom + ((unsigned char)(netno-nom*10));
  txbuf[0]= 0x7F;
  txbuf[1]= 0x02;
  txbuf[2]= nom;
  txbuf[3]= 0x80 | (NomOut & 0x07);
  txbuf[4]= 0 -( txbuf[2] + txbuf[3] );

  //--- надо хитро скопировать данные (после 0x7F вставить DLE)
  txbuf[5] = 0;                                  // SYNC байт
  dest = &txbuf[6];                              // собсно здесь нач-ся данные

  txkol=0;  count = 0; crc = 0;
  while( count<len )
  {
     nom = *(pdata+count);
     *(dest+txkol) = nom;
     crc = crc + nom;
     count++; txkol++;
     if( nom == 0x7F ) { *(dest+txkol) = DLE; txkol++; }
  }

  *(dest+txkol)= 0x7F; txkol++;  // маркер
  *(dest+txkol)= 0x03; txkol++;  // ETX
  *(dest+txkol)= 0 - crc;        // контрольная сумма поля данных

  txkol = txkol + 1 + 1 + 5;     //

  //--- данные готовы, попытаемся передать

  count = 0; fSucs=false;
  while( (!fSucs)&&(count<6) )
  {
     //flc = 0x80 | (NomOut & 0x07);
     //SendKvit( netno, flc );
     LOG(">>>>>-------------------SendDataToKKM WriteFile begin");
     fSucs = WriteFile( hCOM, &txbuf[0], txkol, &txkol, NULL );
     LOG(">>>>>-------------------SendDataToKKM WriteFile end");
     if( fSucs ) {

        fSucs = false;
        LOG(">>>>>-------------------SendDataToKKM WaitKvit begin");
        res = WaitKvit(netno,&flc);
        LOG(">>>>>-------------------SendDataToKKM WaitKvit end");        
        if( res == ENET_SUCCS )
        {
        LOG(">>>>>-------------------SendDataToKKM WaitKvit ENET_SUCCS");
          flc = flc & 0xDF;  // сбросим бит направления
          switch( flc )
          {
            case ACK: { LOG("--ACK");NomOut++; return ENET_SUCCS; }

            case NAK: {LOG("--NAK"); count++; Sleep(20); break; }
            case BUSY:{LOG("--BUSY");Sleep(50); break; }
            case SYN: {
               LOG("--SYN");
               NomIn=0; NomOut=0; Sleep(5);count++;// if(count)count--;
               break;
            }
            default:  {LOG("--????"); count++; }
          }//--- end switch( res )
        }
        else
        {
        LOG(">>>>>-------------------SendDataToKKM WaitKvit ERROR ENET_SUCCS");
         count++;
        }
     }
     else count++;

  }//--- end while

  if( res == ENET_TIMEOUT) { return res; } else return ENET_TX_ERR;

}//<<< EOF SendDataToKKM >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int WaitDataFromKKM(int netno, int maxlen, int *plen, unsigned char *pbuf )
{
  int i,j,res;
  unsigned char flc;

  i=0;  j=0;
  do
  {//--- 10 попыток приема ответа ----
     do
     {//--- ждем заголовок пакета (квитанцию)
        res = WaitKvit( netno, &flc );
        if( res==ENET_SUCCS && ((flc & 0xC0)!=0x80 ))
        {
           switch( flc )
           {
             case SYN:  { NomIn=0; NomOut=0; return ENET_FORMAT;LOG("SYN"); }
             case BUSY: { j=0; break; LOG("BUSY");}
             default: {return ENET_FORMAT;}
           }
        }
        else {j++;LOG("неудачная попытка");}
     } while( j<10 && res!=ENET_SUCCS );

     if( res != ENET_SUCCS ) return ENET_TIMEOUT; // заголовка так и не дождались
     if( res==ENET_SUCCS && ((flc & 0xC0)==0x80) )
     {
       res = WaitData( pbuf, maxlen, plen);
       switch( res )
       {                                            /**************/
          case ENET_SUCCS: { SendKvit( netno, ACK );Sleep(20); return res; }

          case ENET_BADCRC: { SendKvit( netno, NAK); i++; break; }

          default: { return res; }
       }
     } else i++;

  } while( i<5 && res!=ENET_SUCCS);

  return ENET_RX_ERR;

}//<<< End of WaitDataFromKKM() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



int SendKvit(int netno, unsigned char val)
/////////////////////////////////////////////////////////////////////////////
//
//  Отсылает квитанцию val клиенту с сетевым номером netno
//
/////////////////////////////////////////////////////////////////////////////
{
  unsigned char  txbuf[8],nom;
  unsigned long  len;
  bool           fSucs;
  DWORD          Errors;

  if( (netno>0)&&(netno<99))
  {
     nom = ((unsigned char)(netno/10))*16;
     nom = nom + ((unsigned char)(netno-nom*10));
     txbuf[0]= 0x7F;
     txbuf[1]= 0x02;
     txbuf[2]= nom;
     txbuf[3]= val;
     txbuf[4]= 0-( nom + val );

     len = 5;
     fSucs = WriteFile( hCOM, &txbuf[0], len, &len, NULL );

     if( fSucs ) { return ENET_SUCCS; }
       else {
         Errors = CE_BREAK|CE_FRAME|CE_IOE|CE_MODE|CE_OVERRUN|CE_RXOVER|CE_RXPARITY|CE_TXFULL;
         ClearCommError(hCOM, &Errors, NULL);
         return ENET_TX_ERR;
       }
  }
  else return ENET_BADNOM;

}//<<< End of SendKvit() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



int WaitKvit(int netno, unsigned char* value)
/////////////////////////////////////////////////////////////////////////////
//
//  Ожидание/прием квитанции. Если квитанция принята, функция возвращает 0
//  и по адресу value возвращается значение квитанции. Иначе возвращается
//  один из следующих кодов:
//
//    ENET_TIMEOUT - тайм-аут приема
//    ENET_BADCRC  - ошибка контрольной суммы
//    ENET_FORMAT  - нарушен формат или от другого сет. номера
//
/////////////////////////////////////////////////////////////////////////////
{
  unsigned char  rxbuf[16],nom,crc;
  unsigned long  len;
  BOOL           fSucs;

  nom = (unsigned char)netno;
  len = 5;
  fSucs = ReadFile( hCOM, &rxbuf[0], len, &len, NULL );

  if( fSucs && (len==5) )
  {
    crc = rxbuf[2]+rxbuf[3]+rxbuf[4];
    if( crc==0 )
    {
      if( (rxbuf[0]==0x7F)&&(rxbuf[1]==0x02)&&(rxbuf[2]==nom) )
      {
         *value = rxbuf[3];
         return ENET_SUCCS;
      }
      else {LOG("ERROR WaitKvit ENET_FORMAT"); return ENET_FORMAT;}
    }
    else {LOG("ERROR WaitKvit ENET_BADCRC");return ENET_BADCRC;}
  }
  else  {LOG("ERROR WaitKvit ENET_TIMEOUT");return ENET_TIMEOUT;}

}//<<< End of WaitKvit() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int  WaitData(unsigned char *pdata, int maxlen, int *prxkol)
/////////////////////////////////////////////////////////////////////////////
//
//  Прием поля данных в буфер pdata макс длиной maxlen. Коды возврата:
//
//    NET_ERR_TIMEOUT   - тайм-аут при приеме байта
//    NET_ERR_OVERSIZE  - превышение макс. заданного количества байт
//    NET_ERR_FORMAT    - ошибка формата данных
//    NET_ERR_BADCRC    - ошибка контрольной суммы
//
////////////////////////////////////////////////////////////////////////////
{
   unsigned char  ch, crc;
   unsigned long  kolb;
   int            i;
   BOOL           fSucs, fMarker, fEndData;

   // считываем синхро-байт
   kolb = 1;
   fSucs = ReadFile( hCOM, &ch, kolb, &kolb, NULL );
   if( !fSucs || ( kolb != 1 ))  return ENET_TIMEOUT;

   crc = 0;  i = 0;  fMarker = false;  fEndData = false;

   while( (i < maxlen) && (fEndData == false) )
   { /* -1- */

     kolb = 1;
     fSucs = ReadFile( hCOM, &ch, kolb, &kolb, NULL );
     if( (fSucs==false) || (kolb != 1) ) return ENET_TIMEOUT;

     if( ((fMarker == true)&&(ch == 0x03)) != true ) //--- пока не конец ;)
     {/* -2- */

       if( (fMarker==true) && (ch==0x10) ) //--- эта была ситуация Marker:Dle
       {
         *(pdata+i) = 0x7F;
         crc = crc + 0x7F;
         i++;
         fMarker = false;
       }
       else
       {
         if( (fMarker==true)&&(ch != 0x10) )
         {
            return ENET_FORMAT;
         }
         else
         {
            if( (fMarker==false)&&(ch==0x7F) )
            {
              fMarker=true;
            }
            else
            {
              if((fMarker==false)&&(ch!=0x7F))
              {
                 *(pdata+i) = ch;
                 crc = crc + ch;
                 i++;
              };
            };
         };
       };
     }
     else  fEndData = true;       //--- Marker:Etx -конец данных
   };/* -1- * конец цикла приема данных  */


   if( fEndData == false )  return ENET_OVERSIZE;

   // считываем байт CRC
   kolb = 1;
   fSucs = ReadFile( hCOM, &ch, kolb, &kolb, NULL );
   if( !fSucs || ( kolb != 1 ))  return ENET_TIMEOUT;

   crc = crc + ch;
   if( crc != 0 )
   {
      *prxkol = 0;
      return ENET_BADCRC;
   }
   else
   {
      *prxkol = i;
       return ENET_SUCCS;
   }
}//<<< End of WaitData() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


bool StrToBcd(
   unsigned char *pbcd,      // указатель на bcd-число
   int blen,                 // макс. длина bcd-числа в байтах
   unsigned char *pstr,      // указатель на строку
   int slen,                 // длина строки
   int point                 // требуемое положение дес точки
)
{
  int i,j,dec;
  bool fPoint;
  unsigned char *pch, ch, buf[32];

  memset(pbcd,0,blen);       //--- обнуляем результат

  i=0; j=0; dec=0; fPoint=false;
  do
  {//--- ищем точку (если есть), конец строки и заодно проверяем число
     ch=*(pstr+i);
     if( ch>='0' && ch<='9' )
     {
        buf[j]=ch;   // копируем циферьку
        i++; j++;
        if( fPoint ) dec++;
     }
     else
     {
        if( ch=='.' || ch==',' )
        {
          i++;
          if( !fPoint ) { fPoint=true; } else return false;
        }
        else
          if( ch!='\0' ) return false;
     };
  } while( i<slen && ch!='\0' && (dec<=point) && (j<(32-(point-dec))) );

  if( !j ) return true;

  while( dec<point ) { buf[j]='0'; j++; dec++; }

  if(dec>point) j--;  // 1 разряд. остальное отсекается в цикле копирования.

  i=0; pch=pbcd;

  while( j>0 && i<blen*2 )
  {
     ch=buf[j-1];

     if( (i&1) == 0 )
     {
       *pch = ch-0x30;
     }
     if( (i&1) == 1 )
     {
       *pch = *pch | (ch-0x30)*16;
        pch++;
     }
     j--; i++;
  };
  return true;
}//<<< EOF StrToBcd()  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


void IntToBcd( unsigned char *pbcd, int lenb, int val)
//////////////////////////////////////////////////////////////////////////////
//
//  Преобразует число double (только целую часть!) в BCD
//
//////////////////////////////////////////////////////////////////////////////
{
   int i,x,res;
   unsigned char *pch,dgt;

   i=0;  x=val; pch=pbcd;
   while( i < lenb*2 )
   {
      res = x/10;
      dgt = (unsigned char)(x - res*10);
      x=res;

      if( (i&1) == 0 )
      {
         *pch=dgt;
      }
      else
      {
         dgt = dgt<<4;
         dgt = (*pch) | dgt;  *pch=dgt;
         pch++;
      }
      i++;
   }

}//<<< EOF IntToBcd() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



unsigned int  BcdToInt( unsigned char *pbcd, int lenb)
///////////////////////////////////////////////////////////////////////////////
//
//  Преобразует число из BCD-представления в unsigned int.
//  Максимально допустимое значение 4 294 967 295.
//  Если BCD-число имеет большее значение, то возвращается 0.
//
///////////////////////////////////////////////////////////////////////////////
{
   int res,i,pos,mul;
   unsigned char ch;

   res=0;     // результат
   i=0;       // счетчик разрядов
   pos=0;     // счетчик байтов
   mul=1;     // множитель

   while( pos<lenb && pos<5 )
   {
      if( (i&1) == 0 )
      {
         ch=*(pbcd+pos); ch=ch&0x0F;
         res= res + ch * mul;
      }
      else
      {
         ch=*(pbcd+pos); ch=ch&0xF0; ch=ch >> 4;

         if( i<9 || ( i==9 && ch<4 ))
         {
            res = res + ch * mul;
         }
         else
         {
            if( ch==4 && res <= 294967295 )
            {
               res= res + ch * mul;
               return res;
            }
            else return 0;
         }
         pos++;
      }
      i++;  mul=mul*10;
   }
   return res;
}//<<< EOF BcdToInt() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


void DoubleToBcd( unsigned char *pbcd, int lenbcd, double val )
//////////////////////////////////////////////////////////////////////////////
//
//  Преобразует число double (только целую часть!) в BCD
//
//////////////////////////////////////////////////////////////////////////////
{
   int i;
   double  x,res;
   unsigned char *pch,dgt;

/**/   double Corrector;
/**/   if(val>0)Corrector=0.001; else Corrector = -0.001;
/**/   val = val + Corrector;


   x = val - fmod(val,1);      // типа избавляемся от дробной части
   i=0;  pch=pbcd;
   while( i < lenbcd*2 )
   {
      res = fmod(x,10);  x = x/10;
/**/      x = x +Corrector;
/**/      x = x - fmod(x,1);
      dgt = (unsigned char) res;

      if( (i&1) == 0 )
      {
         *pch=dgt;
      }
      else
      {
          dgt = dgt<<4;
          dgt = (*pch) | dgt;  *pch=dgt;
          pch++;
      }

      i++;
   }
}//<<< EOF DoubleToBcd() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


double BcdToDouble( unsigned char *pbcd, int lenbcd )
{
  unsigned char ch;
  double res, mul;
  int    i,pos;

  res = 0; pos=0; mul=1;
  while( pos<lenbcd )
  {
     ch = *(pbcd+pos);
     if( (i&1) == 0 ){ ch=ch & 0x0F; } else { ch=ch & 0xF0; ch=ch>>4; pos++; }
     res = res + ch*mul;
     i++;
  }
  return res;
}//<<< EOF BcdToDouble() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



int  __stdcall Connect(
///////////////////////////////////////////////////////////////////////////////
//   Функция открывает соединение с ККМ через последовательный интерфейс.
//   Возвращаемое значение:
//     SUCCESS - соединение успешно открыто.
//     ERR_INVALID_ARG - неверно заданы параметры соединения а так же при любой
//                       ошибке при открытии порта и неверном пароле
//     ERR_NO_RESPONSE - ККМ не ответил в течении времени
////////////////////////////////////////////////////////////////////////////////
    unsigned char  PortNum,    // номер порта
    unsigned short BaudRate,   // скорость обмена
    unsigned short Timeout,    // тайм-аут (мсек)
    char           *psw        // пароль
)
{
  LOG(">>Connect BEGIN");
  char  portname[8],txbuf[16];
  int   result,ival;
  DWORD val;
  LastDocNum =-1;
    EX_Error = 0;

    if( Timeout < 100 )
    {
       EX_Error = EX_IAE_INVALID_TIMEOUT;
       return ERR_INVALID_ARG;
    }

    if( hCOM!=INVALID_HANDLE_VALUE)
    {
       CloseHandle(hCOM);
       hCOM = INVALID_HANDLE_VALUE;
    }

    //========================================================================
    //  Настройка порта
    //========================================================================

    sprintf(portname,"COM%d", PortNum );    // коныертнем в строку

    hCOM = CreateFile(
             portname,                      //
             GENERIC_READ|GENERIC_WRITE,    // Пробуем получить доступ
             0,                             // к COM-порту
             NULL,                          //
             OPEN_EXISTING,                 //
             FILE_ATTRIBUTE_NORMAL,         //
             NULL                           //
    );
  LOG(">>Connect OPEN Port");
    if( hCOM != INVALID_HANDLE_VALUE )
    {//*1*-----------------------------------------------------------------
     //  Настройка параметров порта
     //--------------------------------------------------------------------
       if( GetCommState(hCOM,&dcb) )
       {//*2*
          switch( BaudRate )
          {
             case  4800: {
                dcb.BaudRate=CBR_4800;
                break;
             }
             case  9600: {
                dcb.BaudRate=CBR_9600;
                break;
             }
             case  19200: {
                dcb.BaudRate=CBR_19200;
                break;
             }
             case  38400: {
                dcb.BaudRate=CBR_38400;
                break;
             }
             case  57600: {
                dcb.BaudRate=CBR_57600;
                break;
             }
             case  115200: {
                dcb.BaudRate=CBR_115200;
                break;
             }
             default:
             {
                EX_Error = EX_IAE_INVALID_BAUD_RATE;
                return ERR_INVALID_ARG;
             }   
          }// eof switch (BaudRate)

          dcb.ByteSize = 8;            // в байте 8 битов
          dcb.fBinary = true;          // альтернативы как бы нет

          dcb.fNull = false;           //

          dcb.fOutxCtsFlow = false;    // disable TS output flow control
          dcb.fOutxDsrFlow = false;    // disable DSR output flow control
          dcb.fErrorChar = false;      // disable error replacement

          dcb.fAbortOnError = true;    // abort reads/writes on error

          dcb.fDtrControl = DTR_CONTROL_DISABLE;  // DTR flow control disable
          dcb.fRtsControl = RTS_CONTROL_DISABLE;  // RTS flow control
          dcb.fDsrSensitivity = false;            // DSR sensitivity disable

          dcb.fOutX = false;                     // disable XON/XOFF out flow control
          dcb.fInX = false;                      // disable XON/XOFF in flow control

          dcb.XonLim = 256;                      // transmit XON threshold
          dcb.XoffLim = 2048;                    // transmit XOFF threshold

          dcb.XonChar = 0x7F;                    // Tx and Rx XON character
          dcb.XoffChar = 0x7F;                   // Tx and Rx XOFF character

          dcb.EvtChar = 0x02;                    // received event character
          dcb.ErrorChar = 0x00;                  // error replacement character
          dcb.EofChar = 0x03;                    // end of input character

          dcb.fTXContinueOnXoff = false;         // XOFF continues Tx (????)

          if( !SetCommState(hCOM, &dcb) )
          {
             CloseHandle(hCOM);
             hCOM = INVALID_HANDLE_VALUE;
             return ERR_INVALID_ARG;
          }
       }
       else
       {
          CloseHandle(hCOM);
          hCOM = INVALID_HANDLE_VALUE;
          return ERR_INVALID_ARG;
       }//*2*

    }//*1*

    else
    {
      EX_Error = EX_IAE_INVALID_PORT_NUM;
      return ERR_INVALID_ARG;
    };


    //---------------------------------------------------------------------
    //  Настройка тайм-аутов
    //---------------------------------------------------------------------

    if( GetCommTimeouts(hCOM, &sTO) )
    {
      sTO.ReadTotalTimeoutConstant = Timeout;
      sTO.ReadTotalTimeoutMultiplier = 3*2;
      sTO.ReadIntervalTimeout = 3*2;
      sTO.WriteTotalTimeoutConstant = 100*2;
      sTO.WriteTotalTimeoutMultiplier = 5*2;

      if( !SetCommTimeouts( hCOM, &sTO ) ) {
        CloseHandle( hCOM );
        hCOM = INVALID_HANDLE_VALUE;
        EX_Error = EX_IAE_INVALID_PORT_NUM;
        return ERR_INVALID_ARG;
      }
    }
    else
    {
      CloseHandle(hCOM);
      hCOM = INVALID_HANDLE_VALUE;
      EX_Error = EX_IAE_INVALID_PORT_NUM;
      return ERR_INVALID_ARG;
    }

    PurgeComm(hCOM,PURGE_TXABORT|PURGE_RXABORT|PURGE_TXCLEAR|PURGE_RXCLEAR);
    ClearCommError(hCOM,&val,NULL);
    LOG(">>Connect Port configured");
    //========================================================================
    //  Запрос текщего состояния. Проверяем режим, если в кассовом, то надо
    //  выйти в главное меню
    //========================================================================
    result=GetStateKKM( 1, &ival );
    LOG(">>Connect GetStateKKM end");
//    Sleep(50);
    if( result==ENET_SUCCS )
    {
       switch( ival )
       {
         case 0: // в главном меню
         {
           CurrMode=0;
           memset( password, '0', 16 );
           #ifdef password4
           strncpy( &password[2], psw, 4 );
           #else
           strncpy( &password[0], psw, 6 );
           #endif
           EX_Error=0;
           return SUCCESS;
         }
         case 1: // надо выйти из кассового режима
         {
           LOG(">>Connect ExitFromCashMode begin");
           result = ExitFromCashMode();
           LOG(">>Connect ExitFromCashMode end");
           if( result==SUCCESS )
           {
              CurrMode=0;
              memset( password, '0', 16 );
              #ifdef password4
              strncpy( &password[2], psw, 4 );
              #else
              strncpy( &password[0], psw, 6 );
              #endif
              EX_Error=0;
              return SUCCESS;
           }
           else
           {
              CurrMode=-1;
              memset( password, '*', 16 );
              return result;
           }
         }
       }
    }
    else // ответ на запрос состояния не получили
    {
      EX_Error = result;
      return RecodeErrorKKM( &EX_Error );
    }
}//<<< EOF Connect() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

int __stdcall Disconnect( void )
{
   if( hCOM!=INVALID_HANDLE_VALUE ) CloseHandle( hCOM );
   hCOM = INVALID_HANDLE_VALUE;

   CurrMode= -1;
   memset( password,'*',16 );

   return SUCCESS;
}//<<< EOF Disconnect() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

int  __stdcall SendText(char *Text )
//////////////////////////////////////////////////////////////////////////////
//
//  Печать текстовой строки
//
//////////////////////////////////////////////////////////////////////////////
{
 int res, kol, i;
 unsigned char txbuf[64], rxbuf[256];
 EX_Error = 0;
 if( hCOM==INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;
 memset( &txbuf[0], 0, 34 );
 txbuf[0]=2; txbuf[1]=16;
 strncpy(&txbuf[2],Text,32);
 res = SendDataToKKM( 1, 34, &txbuf[0] );
 if( res==ENET_SUCCS ) //команда передана, ждем ответа
   {
      res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
      if( res==ENET_SUCCS )
      {

        if( rxbuf[2]==0 )
        {
           return SUCCESS;
        }
        else
        {
           EX_Error = rxbuf[2];
           return RecodeErrorKKM( &EX_Error );
        }

      }//--- ошибка при приеме ответа
      else
      {
         EX_Error = res;
         return RecodeErrorKKM ( &EX_Error );
      }
   }
   else
   {
      EX_Error = res;
      return RecodeErrorKKM( &EX_Error);   // ошибка передачи команды
   }
 return ERR_ECR_ERROR;            // ошибка передачи команды
}


int __stdcall RegisterOper( int OperNum, char *OperName )
//////////////////////////////////////////////////////////////////////////////
//  Регистрация оператора на ККМ.
//  В нашем случае просто входим в кассовый режим с паролем, переданным
//  в фунции Connect.  Аргументы OperNum и OperName игнорируются.
//////////////////////////////////////////////////////////////////////////////
{
 int res, kol=3, i;
 unsigned char txbuf[32], rxbuf[256];

 EX_Error = 0;
 if( hCOM==INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;

 while( (kol--)>0 )
 {
     txbuf[0]=2; txbuf[1]=2;  txbuf[2]=1;
     memset( &txbuf[3], '0', 16 );
     memcpy( &txbuf[3], password, 6 );

     res = SendDataToKKM( 1, 19, &txbuf[0] );
     if( res==ENET_SUCCS ) //команда передана, ждем ответа
     {

        res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
        if( res==ENET_SUCCS )
        {

          if( rxbuf[2]==0 )
          {
             Operator = OperNum;
             CurrMode = 1;
             Sleep(300);
             return SUCCESS;
          }
          else
          {
             EX_Error = rxbuf[2];
             RecodeErrorKKM( &EX_Error );
          }

        }//--- ошибка при приеме ответа

        else
        {

          EX_Error = res;
          if(kol==1)return RecodeErrorKKM ( &EX_Error );
        }
     }
     else
     {
        
        EX_Error = res;
        return RecodeErrorKKM( &EX_Error);   // ошибка передачи команды
     }

 }//eof while( !fStop )

 return ERR_ECR_ERROR;            // ошибка передачи команды
}


int __stdcall GetCurrOper(int *OperNum)
{
   if( hCOM==INVALID_HANDLE_VALUE )
   {
      *OperNum = -1;
      return ERR_CONN_CLOSED;
   }

   else { *OperNum=Operator; return SUCCESS; }
}//<<< EOF  GetCurrOper()  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int __stdcall GetTaxRate(
///////////////////////////////////////////////////////////////////////////////
// Описание:
//    Cчитывает налоговую ставку с заданным номером.
// Параметры:
//    TaxIndex - номер налоговой ставки.
//    TaxVal   - указатель на переменную, в которую будет помещен результат.
//               Результат должен быть представлен в сотых долях процента.
//    Name     - наименование налоговой ставки.
//
//  Возвращаемые значения:
//    SUCCESS          - нет ошибки
//    ERR_CONN_CLOSED  - соединение с ККМ не открыто
//    ERR_NO_RESPONSE  - ККМ не отвечает
///////////////////////////////////////////////////////////////////////////////
       int  TaxIndex,
       int  *TaxVal,
       char *Name
)
{
 int res, i;
 unsigned char txbuf[32], rxbuf[256];

  EX_Error = 0;

  if( hCOM==INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;
  if( TaxIndex<1 || TaxIndex > 5 )
  {
     EX_Error = EX_IAE_INVALID_TAX_INDEX;
     return ERR_INVALID_ARG;
  }

  txbuf[0]=2; txbuf[1]=10;  txbuf[2]= (unsigned char)TaxIndex;

  res = SendDataToKKM( 1, 3, &txbuf[0] );
  if( res==ENET_SUCCS ) //команда передана, ждем ответа
  {
     res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
     if( res==ENET_SUCCS )
     {
       if( rxbuf[2]==0 )
       {
           if( rxbuf[3]== 0xAA)
           {
             *TaxVal=BcdToInt(&rxbuf[5],2);   // налоговая ставка

             i=0;                             //
             while( i<12 && rxbuf[7+i]!=0x0 ) //
             {                                // наименование налога
               *(Name+i)=rxbuf[7+i]; i++;     //
             }                                //
             *(Name+i)=0x0;                   //
             return SUCCESS;
           }
           else
           {
              *TaxVal=0; *Name=0x0;
              return ERR_VALUE_NOT_DEFINED;
           }
       }
       else
       {
          EX_Error = rxbuf[2];
          return RecodeErrorKKM( &EX_Error );
       }
     }//--- ошибка при приеме ответа

     else
     {
        EX_Error = res;
        return RecodeErrorKKM( &EX_Error );
     }
  }
  else
  {
    EX_Error = res;
    return RecodeErrorKKM( &EX_Error);        // ошибка передачи команды
  }
}//<<< EOF  GetTaxRate() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int __stdcall GetTaxNum(int *TaxNum)
///////////////////////////////////////////////////////////////////////////////
//  Описание:
//	Запрашивает количество налоговых ставок находящихся
//            в памяти ККМ.
//  Параметры:
//            TaxNum - указатель на переменную, в которую будет помещен
//                     результат.
//  Возвращаемые значения:
//            SUCCESS  - нет ошибки
//            ERR_CONN_CLOSED  - соединение с ККМ не открыто
//            ERR_NO_RESPONSE   - ККМ не отвечает
///////////////////////////////////////////////////////////////////////////////
{
 int res,i;
 unsigned char txbuf[32], rxbuf[256];

  EX_Error = 0;
  if( hCOM==INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;

  txbuf[0]=2; txbuf[1]=11;  txbuf[2]= 0;

  res = SendDataToKKM( 1, 3, &txbuf[0] );
  if( res==ENET_SUCCS ) //команда передана, ждем ответа
  {
     res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
     if( res==ENET_SUCCS )
     {
       if( rxbuf[2]==0 )
       {
           *TaxNum = rxbuf[3];
           return SUCCESS;
       }
       else
       {
          EX_Error = rxbuf[2];
          return RecodeErrorKKM( &EX_Error );
       }
     }//--- ошибка при приеме ответа

     else
     {
        EX_Error = res;
        return RecodeErrorKKM( &EX_Error );  // ошибка передачи команды
     }
  }
  else
  {
     EX_Error = res;
     return RecodeErrorKKM( &EX_Error );  // ошибка передачи команды
  }
}//<<< EOF  GetTaxNum()  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int  __stdcall OpenReceipt(int OperType)
///////////////////////////////////////////////////////////////////////////////
// Описание:
//	Функция начинает формирование чека заданного типа.
//  Параметры:
//         OperType
//         Тип операции:
//         0 - продажа;
//         1 - возврат товара;
//         2 - внесение наличности;
//         3 - выплата наличности;
//  Возвращаемые значения:
//    SUCCESS - нет ошибки
//    ERR_CONN_CLOSED - соединение с ККМ не открыто
//    ERR_NO_RESPONSE - ККМ не отвечает
//    ERR_REC_OPENED  - чек уже открыт
//    ERR_INVALID_ARG  - неверное значение аргумента.
//    ERR_ECR_ERROR  - ошибка ККМ
///////////////////////////////////////////////////////////////////////////////
{
    EX_Error = 0;
    if( OperType<0 || OperType>3)
    {
       EX_Error = EX_IAE_INVALID_OPER_TYPE;
       return ERR_INVALID_ARG;
    }

    DocType = OperType;  opcur = 0;
    return SUCCESS;
}//<<< EOF  OpenReceipt() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



int __stdcall  AddRecEntry(
///////////////////////////////////////////////////////////////////////////////
//  Описание:
//	Функция добавляет позиции в чек.
//
//  Параметры Depart, Code, Quantity, QuantityPrec,
//  TaxGroup и Name игнорируются для операций внесения / выплаты наличности.
//
//  Возвращаемые значения:
//      SUCCESS          - нет ошибки
//      ERR_REC_NOOPEN   - нет открытого чека
//	ERR_CONN_CLOSED  - соединение с ККМ не открыто
//	ERR_NO_RESPONSE  - ККМ не отвечает
//	ERR_DOC_OVERFLOW - слишком большое число позиций чека;
//	ERR_INVALID_ARG  - неверное значение аргумента.
//	ERR_ECR_ERROR    - ошибка ККМ.
//
// ****************** ФОРМАТ КОМАНДЫ ДЛЯ ККМ *******************************
//
// 3	OpCode	1	BIN	код операции (A3H,A5H,ADH,AEH)
// 4	OpNum	1	BCD	Номер посл. Операции в чеке +1
// 5	Rezerved	3	BIN	Зарезервировано, обнулять
// 8	ItemName	32	ASCIIZ	Наименование товара***
// 40	ItemPrice	5	BCD	Цена единицы товара
// 45	TaxesCode	1	BIN	Код варианта налогообложения
// 46	DepthNum	1	BIN	Номер отдела (секции)
// 47	OpFlags	1	BIN	Флаги (не используется, обнулять)
// 48	Kolvo	5	BCD	Количество
// 53	EdName	5	ASCIIZ	Наименование единицы (не исп, обнулять)
//	Итого	58
///////////////////////////////////////////////////////////////////////////////

      double Price,            // цена товара/услуги
      int Quantity,            // количество
      int  QuantityPrec,       // положение запятой
      double Sum,              // сумма (нафига правда не понял)
      int Depart,              // отдел
      int TaxIndex,            // налоговая ставка
      int Code,                // код
      char *Name               // наименование
)
{
  unsigned char  ch;
  double         price;
  int            i,kolvo,res;

  EX_Error = 0;

  if( hCOM==INVALID_HANDLE_VALUE) return ERR_CONN_CLOSED;
  if( DocType < 0 || DocType>3 )
  {
     EX_Error = EX_IAE_INVALID_OPER_TYPE;
     return ERR_REC_NOOPEN;
  }

  if( DocType < 2 )//---- продажа или возврат
  {
    if( Price <= 0 )
    {
       EX_Error = EX_IAE_INVALID_ENTRY_SUM;
       return ERR_INVALID_ARG;
    }
    if( Quantity<=0 || QuantityPrec>3 || QuantityPrec<0)
    {
       EX_Error = EX_IAE_INVALID_QUANTITY;
       return ERR_INVALID_ARG;
    }
    if( Depart<1 || Depart>16)
    {
       EX_Error = EX_IAE_INVALID_DEPARTMENT;
       return ERR_INVALID_ARG;
    }
    if( TaxIndex <0 || TaxIndex>5 )
    {
       EX_Error =   EX_IAE_INVALID_TAX_INDEX;
       return ERR_INVALID_ARG;
    }

    price = Price*100;       // у нас в копейках
    if( price> 9999999999 )
    {
       EX_Error = EX_IAE_INVALID_ENTRY_SUM;
       return ERR_INVALID_ARG;
    }

    switch( QuantityPrec )
    {
       case 0: { kolvo = Quantity*1000; break; }
       case 1: { kolvo = Quantity*100;  break; }
       case 2: { kolvo = Quantity*10;   break; }
       case 3: { kolvo = Quantity;      break; }
       default:
       {
         EX_Error = EX_IAE_INVALID_QUAN_PREC;
         return ERR_INVALID_ARG;
       }
    }

    if( kolvo>9999999999)
    {
       EX_Error = EX_IAE_INVALID_QUANTITY;
       return ERR_INVALID_ARG;
    }

    //=========================================================================
    //  Сохраняем данные по операции
    //=========================================================================
    if(Code==2)LOG("AddRecEntry Code==2");else LOG("AddRecEntry Code!=2");
    IntToBcd( &DocData[opcur].plu[0],3, Code);           // Код товара/услуги
    if(DocData[opcur].plu[0]!=0||DocData[opcur].plu[1]!=0||DocData[opcur].plu[2]!=0)
      LOG("AddRecEntry plu!=0");else LOG("AddRecEntry plu==0");
    DoubleToBcd( &DocData[opcur].summa[0], 5, price );   // цена
    DocData[opcur].tax = (unsigned char) TaxIndex;       // код налоговой ставки
    DocData[opcur].depth = (unsigned char) Depart;       // номер отдела
    IntToBcd( &DocData[opcur].kolvo[0], 5, kolvo );      // количество

    i=0; ch= *(Name+i);                      //
    while( i<32 && ch!=0x0 )                 // копируем наименование
    {                                        //
       ch = *(Name+i);                       //
       DocData[opcur].tovname[i]=ch;         //
       i++;                                  //
    }                                        //
    if(i<32) DocData[opcur].tovname[i]='\0'; //

    if( DocType==0 )
    {
       DocData[opcur].optype=0;             // Продажа/услуга
       DocData[opcur].uidop= 0xA3;          //
    }
    else
    {
       DocData[opcur].optype=1;            //  Возврат
       DocData[opcur].uidop=0xAD;          //
    }
    DocData[opcur].opnum = opcur;  opcur++;
    return SUCCESS;
  }
  else //------ внесение или выплата
  {
     price = Sum*100;                      // переводим в копейки
     if( price<=0 || price>9999999999 )
     {
       EX_Error = EX_IAE_INVALID_ENTRY_SUM;
       return ERR_INVALID_ARG;
     }

     DoubleToBcd( &DocData[opcur].summa[0], 5, price );
     DocData[opcur].optype=DocType;
     DocData[opcur].opnum = opcur;  opcur++;
     return SUCCESS;
  }
}//<<< EOF  AddRecRntry() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



int __stdcall AddRecAdjust(double Sum, char *Text )
///////////////////////////////////////////////////////////////////////////////
//
//  Описание:
//        Функция добавляет общую скидку/надбавку на чек.
//  Параметры:
//        Sum - сумма скидки/надбавки
//        Text - наименование скидки/надбавки
//  Возвращаемые значения:
//        SUCCESS - нет ошибки
//        ERR_REC_NOOPEN  - нет открытого чека
//        ERR_CONN_CLOSED  - соединение с ККМ не открыто
//        ERR_NO_RESPONSE  - ККМ не отвечает
//        ERR_DOC_OVERFLOW - слишком большое число позиций чека;
//        ERR_INVALID_ARG  - неверное значение аргумента.
//        ERR_ECR_ERROR - ошибка ККМ.
//
// ********************* Формат команды для ККМ *******************************
//  0	VectorNom	1	BIN	2 - номер вектора
//  1	FuncNom	        1	BIN	5 - номер функции
//  2	OpCode	        1	BIN	код операции (C4H,C5H)
//  3	OpNum	        1	BIN	Номер посл. Операции в чеке +1
//  4	Summa	        7	BCD	Сумма скидки/надбавки
///////////////////////////////////////////////////////////////////////////////
{
 int           res,i;
 bool          fDisc;
 double        summa;

  EX_Error = 0;

  if( hCOM==INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;

  if( DocType != 0 )
  {
      EX_Error = EX_IAE_INVALID_ENTRY_TYPE;
      return ERR_INVALID_ARG;
  }

  if( Sum < 0 ){fDisc=true; summa = -1*Sum;} else {fDisc=false; summa = Sum;}

  summa=summa*100;

  if( summa>9999999999)
  {
     EX_Error = EX_IAE_INVALID_ADJUSTMENT;
     return ERR_INVALID_ARG;
  }

  if( fDisc )
  {
     DocData[opcur].optype = 10;
     DocData[opcur].uidop=0xC4;
     LOG("AddRecAdjust 0xC4");
  }
  else
  {
     DocData[opcur].optype = 11;
     DocData[opcur].uidop=0xC5;
     LOG("AddRecAdjust 0xC5");     
  }

  DoubleToBcd( &DocData[opcur].summa[0], 7, summa );
  DocData[opcur].opnum = opcur; opcur++;

  return SUCCESS;
}//<<< EOF  AddRecAdjust() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int __stdcall  AddPay( int PayType, double SumCash, double SumCashless )
///////////////////////////////////////////////////////////////////////////////
//  Описание:
//	Функция добавляет значение уплаченной суммы в чек. Конкретно у нас
//      просто сохраняем эту сумму, отошлем при закрытии чека
//
//  Параметры:
//     PayType - тип оплаты
//       0 - наличные;
//       1 - кредит;
//       2 - платежная карта;   (у нас не катит)
//       3 - наличные + кредит; (у нас не катит)
//       4 - наличные + платежная карта. (у нас не катит)
//
//     SumCash     - сумма уплаченная наличными. Игнорируется в случае только
//                   безналичной оплаты.
//     SumCashless - сумма уплаченная по безналичному расчет. Игнорируется
//                   в случае только наличной оплаты.
//
//  Возвращаемые значения:
//    SUCCESS - нет ошибки
//    ERR_REC_NOOPEN - нет открытого чека
//    ERR_CONN_CLOSED - соединение с ККМ не открыто
//    ERR_NO_RESPONSE  - ККМ не отвечает
//    ERR_DOC_OVERFLOW  - слишком большое число позиций чека;
//    ERR_INVALID_ARG  - неверное значение аргумент.
//    ERR_ECR_ERROR  - ошибка ККМ
//
///////////////////////////////////////////////////////////////////////////////
{
  double summa;

  EX_Error = 0;
  if( hCOM==INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;

  if( DocType != 0 )
  {
    EX_Error = EX_IAE_INVALID_ENTRY_TYPE;
    return ERR_INVALID_ARG;
  }

  if( PayType<0 || PayType>2 )
  {
    EX_Error = EX_IAE_UNSUPPORTED_PAY_TYPE;
    return ERR_INVALID_ARG;
  }

  if( PayType == 0 )
  {
     summa = SumCash*100;
     DocData[opcur].uidop = 0;
  }
  else
  {
     summa = SumCashless*100;
     DocData[opcur].uidop = 1;
  }

  DocData[opcur].optype = 12;
  DoubleToBcd( &DocData[opcur].summa[0], 7, summa );
  DocData[opcur].opnum = opcur; opcur++;
  return SUCCESS;
}


int __stdcall CloseReceipt( int flag )
//////////////////////////////////////////////////////////////////////////////
// Описание:
//     Функция закрывает чек и выводит его на печать.
// Параметры:
//     flag:
//     0 - закрыть чек не распечатывая(отмена чека).
//     1 - закрыть и вывести чек на печать.
// Возвращаемые значения:
//           SUCCESS           - нет ошибки;
//           ERR_REC_NOOPEN    - нет открытого чека;
//           ERR_CONN_CLOSED   - соединение с ККМ не открыто;
//           ERR_NO_RESPONSE   - ККМ не отвечает;
//           ERR_DOC_OVERFLOW  - слишком большое число позиций чека;
//           ERR_INVALID_ARG   - неверное значение аргумент;
//           ERR_ECR_ERROR     - ошибка ККМ;
//           ERR_END_OF_PAPER  - закончилась чековая лента;
//           ERR_INTERNAL      - внутренняя ошибка драйвера;
//////////////////////////////////////////////////////////////////////////////
{
  unsigned char  txbuf[64],rxbuf[256];
  int            i, j, res, xres, txlen, errs;
  bool           fDocEnd;

  EX_Error = 0;

  if( hCOM==INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;

  switch( flag )
  {
    case 0: //--- аннулируем открытый чек
    {
       txbuf[0]=2; txbuf[1]=6; txbuf[2]=0; txlen = 3;

       res = SendDataToKKM( 1, txlen, txbuf );
       if( res==ENET_SUCCS ) //команда передана, ждем ответа
       {
          res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
          if( res==ENET_SUCCS )
          {
            if( rxbuf[2]==0 )
            {
               opcur = 0; DocType=-1;
               return SUCCESS;
            }
            else
            {
               if( rxbuf[2]== ENET_BADMODE )
               {
                  opcur = 0; DocType=-1;
                  return SUCCESS;
               }
               else
               {
                  EX_Error = rxbuf[2];
                  return RecodeErrorKKM( &EX_Error );
               }
            }
          }
          else //--- ошибка при приеме ответа
          {
             EX_Error = res;
             return RecodeErrorKKM( &EX_Error );   // бум считать ошибкой кассы
          }
       }
       else
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );   // бум считать ошибкой кассы
       }
    }
    case 1: //--- закрываем текущий документ
    {
       if( opcur<1 || DocType < 0 || DocType>3 )  return ERR_REC_NOOPEN;

       //* если документ - обычный чек, и последняя запись не внесение суммы,
       //* то сформируем таковую с нулевой суммой внесения и типом наличные
       if( DocType==0 && DocData[opcur-1].optype!=12 )
       {
          DocData[opcur].optype=12;   // типа сумма, внесенная покупателем
          DocData[opcur].uidop = 0;   // типа наличными
          memset( &DocData[opcur].summa[0], 0x0, 7);    // но нулевая
          DocData[opcur].opnum = opcur; opcur++;
       }

       i=0;  fDocEnd =false;  errs =0;

       while( i<opcur && i<255 )
       {
         switch( DocData[i].optype )
         {
            case 0: //- продажа
            {
               memset( txbuf, 0x0, 64 );
               txbuf[0]=2; txbuf[1]=4;
               txbuf[3]=DocData[i].uidop; txbuf[4]=(unsigned char)(i+1);
               memcpy( &txbuf[5], &DocData[i].plu, 3);
               if(txbuf[5]!=0||txbuf[6]!=0||txbuf[7]!=0)LOG("close txbuf[5..7]!=0");else LOG("close txbuf[5..7]==0");
               memcpy( &txbuf[8], &DocData[i].tovname, 32);
               memcpy( &txbuf[40], &DocData[i].summa, 5); //! 40  //az 35
               memcpy( &txbuf[45], &DocData[i].tax, 2 );  //! 45  //az 40
               memcpy( &txbuf[48], &DocData[i].kolvo, 5); //! 48  //az 43
               txlen = 58;
               break;
            }
            case 1: //- возврат
            {
               memset( txbuf, 0x0, 64 );
               txbuf[0]=2; txbuf[1]=4;
               txbuf[3]=DocData[i].uidop; txbuf[4]=(unsigned char)(i+1);

               memcpy( &txbuf[5], &DocData[i].plu, 3);
               memcpy( &txbuf[8], &DocData[i].tovname, 32);
               memcpy( &txbuf[40], &DocData[i].summa, 5); //!40
               memcpy( &txbuf[45], &DocData[i].tax, 2 );  //!45
               memcpy( &txbuf[48], &DocData[i].kolvo, 5); //!48
               txlen = 58;  fDocEnd = true;
               break;
            }
            case 2: //- внесение
            {
               txbuf[0]=2; txbuf[1]=7;  txbuf[2]=3;
               memcpy( &txbuf[3], DocData[i].summa, 7 );
               txlen = 10;
               fDocEnd = true;
               break;
            }
            case 3: //- выплата
            {
               txbuf[0]=2; txbuf[1]=7; txbuf[2]=4;
               memcpy( &txbuf[3], DocData[i].summa, 7 );
               txlen = 10;
               fDocEnd = true;
               break;
            }
            case 10: //- скидка
            {
               txbuf[0]=2; txbuf[1]=5; txbuf[2]=0xC4;
               txbuf[3]=DocData[i].opnum;
               memcpy( &txbuf[4], DocData[i].summa, 7 );
               txlen = 11;
               break;
            }
            case 11: //- надбавка
            {
               txbuf[0]=2; txbuf[1]=5; txbuf[2]=0xC5;
               txbuf[3]=DocData[i].opnum;
               memcpy( &txbuf[4], DocData[i].summa, 7 );
               txlen = 11;
               break;
            }
            case 12: //- сумма, внесенная покупателем
            {
               txbuf[0]=2; txbuf[1]=7;  txbuf[2]=0;
               if( DocData[i].uidop == 0 ) { txbuf[2]=0; } else txbuf[2]=1;
               memcpy( &txbuf[3], DocData[i].summa, 7 );
               txlen = 10;
               fDocEnd = true; // не уверен
               break;
            }
            default: return ERR_INTERNAL;
         }//* eof switch

         LOG("-----{");
         LOG("SendDataToKKM");
         res = SendDataToKKM( 1, txlen, txbuf );
         if( res==ENET_SUCCS ) //команда передана, ждем ответа
         {
            LOG("SendDataToKKM OK");

            res=WaitDataFromKKM( 1, 256, &j, &rxbuf[0] );
            if( res==ENET_SUCCS )
            {
             LOG("WaitDataFromKKM OK");
             LOG("-----}");
              if( rxbuf[2]==0 )
              {
                LOG("KKM OK");
                 if( fDocEnd == true )
                 {
                    LOG("Close Check");
                    DocType = -1; opcur = 0;
                    LastDocNum =  *(int*)(rxbuf+5);
                    return SUCCESS;
                 }
//                 Sleep(50);             // чтоб касса не офигела
                 i++;                  // следующая
              }
              else
              {//--- анализируем ошибку
                  LOG("KKM error");
                  EX_Error = rxbuf[2];
                  return RecodeErrorKKM( &EX_Error );
              }
            }//--- ошибка при приеме ответа
            else
            {
               LOG("WaitDataFromKKM Error");
               EX_Error = res;
               return RecodeErrorKKM( &EX_Error );
            }
         }
         else
         {
            errs++;                             // не смогли передать команду
            LOG("SendDataToKKM Error");
            if( errs>5 )
            {
               EX_Error = res;
               return RecodeErrorKKM( &EX_Error );
            }
//            Sleep(50);
         }
       }
       return ERR_INTERNAL;  // выход должен произойти внутри цикла
    }//* eof Close Receipt case
  }//* eof switch(flag)
}

int  __stdcall  GetLastDocNum(void)
 {
  int Res=0,mn=1,LastDN=LastDocNum;
  for(int i=1;i<=8;i++)
   {
    Res+=(LastDN&0xf)*mn;
    mn*=10;
    LastDN=LastDN>>4;
   }
  return Res;
 }

int __stdcall Zreport( void )
///////////////////////////////////////////////////////////////////////////////
//   Описание:  	Выводит на печать Z-отчет.
//
//   Возвращаемые значения:
//     SUCCESS          - нет ошибки
//     ERR_CONN_CLOSED  - соединение с ККМ не открыто
//     ERR_NO_RESPONSE  - ККМ не отвечает
//     ERR_REC_OPENED   - чек уже открыт
//     ERR_ECR_ERROR    - ошибка ККМ
///////////////////////////////////////////////////////////////////////////////
{
  int  res, ival,i;
  unsigned char txbuf[32],rxbuf[256];

  if( hCOM==INVALID_HANDLE_VALUE && CurrMode<0 ) return ERR_CONN_CLOSED;

  res = GetStateKKM( 1, &ival );
  if( res == ENET_SUCCS )
  {
    if( ival != 0 )
    {
       res = ExitFromCashMode();
       if( res!=SUCCESS )
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );
       }
    }

    txbuf[0]=2; txbuf[1]=13;  txbuf[2]= 0;
    memset( &txbuf[3], '0', 16 );
    memcpy( &txbuf[3], password, 6 );

    res = SendDataToKKM( 1, 19, &txbuf[0] );
    if( res==ENET_SUCCS ) //команда передана, ждем ответа
    {
       res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
       if( res==ENET_SUCCS )
       {
          if( rxbuf[2]==0 ) { return SUCCESS; }
            else
            {
                EX_Error = rxbuf[2];
                return RecodeErrorKKM( &EX_Error );
            }
       }
       else
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );
       }
    }
    else
    {
        EX_Error = res;
        return RecodeErrorKKM( &EX_Error );  // ошибка передачи команды
    }
  }
  else
  {
     EX_Error = res;
     return RecodeErrorKKM( &EX_Error );
  }
}


int __stdcall Xreport( void )
///////////////////////////////////////////////////////////////////////////////
//   Описание:  	Выводит на печать Z-отчет.
//
//   Возвращаемые значения:
//     SUCCESS          - нет ошибки
//     ERR_CONN_CLOSED  - соединение с ККМ не открыто
//     ERR_NO_RESPONSE  - ККМ не отвечает
//     ERR_REC_OPENED   - чек уже открыт
//     ERR_ECR_ERROR    - ошибка ККМ
///////////////////////////////////////////////////////////////////////////////
{
  int  res, ival,i;
  unsigned char txbuf[32],rxbuf[256];

  if( hCOM==INVALID_HANDLE_VALUE && CurrMode<0 ) return ERR_CONN_CLOSED;

  res = GetStateKKM( 1, &ival );
  if( res == ENET_SUCCS )
  {
    if( ival != 0 )
    {
       res = ExitFromCashMode();
       if( res!=SUCCESS )
       {
         if( res == ENET_TIMEOUT ) { return ERR_NO_RESPONSE; }
           else return ERR_ECR_ERROR;
       }
    }

    txbuf[0]=2; txbuf[1]=14;  txbuf[2]= 0;
    memset( &txbuf[3], '0', 16 );
    memcpy( &txbuf[3], password, 6 );

    res = SendDataToKKM( 1, 19, &txbuf[0] );
    if( res==ENET_SUCCS ) //команда передана, ждем ответа
    {
       res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
       if( res==ENET_SUCCS )
       {
         if( rxbuf[2]==0 ) { return SUCCESS; }
            else
            {
               EX_Error = rxbuf[2];
               return RecodeErrorKKM( &EX_Error );
            }
       }
       else
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );
       }
    }
    else
    {
       EX_Error = res;
       return RecodeErrorKKM( &EX_Error );
    }
  }
  else
  {
     EX_Error = res;
     return RecodeErrorKKM( &EX_Error );
  }
}


int __stdcall GetExErrorCode( void )
{
   return EX_Error;
}


int __stdcall QueryEcrIdent(
//////////////////////////////////////////////////////////////////////////////
// Описание:
//	Функция получает информацию о модели и версии ПО ККМ.
// Параметры:
//            Все параметры строки длиной 31 символ. Последний(31-й) символ 0x00.
//	ModelName - Наименование модели(например 'MERCURY-114.1F')
//      Manufacturer  - Производитель
//      FirmvareVersion -  Версия ПО(например '1.0')
///////////////////////////////////////////////////////////////////////////////
    char  *ModelName,
    char  *Manufacturer,
    char  *FirmvareVersion
)
{
   unsigned char txbuf[16],rxbuf[256], *dest;
   int           res,i;

   EX_Error = 0;
   if( hCOM==INVALID_HANDLE_VALUE && CurrMode<0 ) return ERR_CONN_CLOSED;

   txbuf[0]=2; txbuf[1]=15;  txbuf[2]= 0;
   res = SendDataToKKM( 1, 3, &txbuf[0] );
   if( res==ENET_SUCCS )
   {
       res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
       if( res==ENET_SUCCS )
       {
          if( rxbuf[2]==0 )
          {
             i=0; dest=ModelName;
             memset( dest,'\0',31);
             while( i<16 && rxbuf[3+i]!='\0') {*dest=rxbuf[3+i];dest++;i++;}

             i=0; dest=FirmvareVersion;
             memset( dest,'\0',31);
             while( i<12 && rxbuf[31+i]!='\0') {*dest=rxbuf[31+i];dest++;i++;}

             dest=Manufacturer;
             memset( dest,'\0',31);
             strncpy( dest, "Incotex", 31);
             return SUCCESS;
          }
          else
          {
             EX_Error = rxbuf[2];
             return RecodeErrorKKM( &EX_Error );
          }
       }
       else
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );
       }
   }
   else
   {
      EX_Error = res;
      return RecodeErrorKKM( &EX_Error );
   }
}
int __stdcall QueryEcrIdentEx(
//////////////////////////////////////////////////////////////////////////////
// Описание:
//	Функция получает информацию о модели и версии ПО ККМ.
// Параметры:
//            Все параметры строки длиной 31 символ. Последний(31-й) символ 0x00.
//	ModelName - Наименование модели(например 'MERCURY-114.1F')
//      Manufacturer  - Производитель
//      FirmvareVersion -  Версия ПО(например '1.0')
//      SN -  серийный номер
///////////////////////////////////////////////////////////////////////////////
    char  *ModelName,
    char  *Manufacturer,
    char  *FirmvareVersion,
    char  *SN
)
{
   unsigned char txbuf[16],rxbuf[256], *dest;
   int           res,i;

   EX_Error = 0;
   if( hCOM==INVALID_HANDLE_VALUE && CurrMode<0 ) return ERR_CONN_CLOSED;

   txbuf[0]=2; txbuf[1]=15;  txbuf[2]= 0;
   res = SendDataToKKM( 1, 3, &txbuf[0] );
   if( res==ENET_SUCCS )
   {
       res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
       if( res==ENET_SUCCS )
       {
          if( rxbuf[2]==0 )
          {
             i=0; dest=ModelName;
             memset( dest,'\0',31);
             while( i<16 && rxbuf[3+i]!='\0') {*dest=rxbuf[3+i];dest++;i++;}

             i=0; dest=FirmvareVersion;
             memset( dest,'\0',31);
             while( i<12 && rxbuf[31+i]!='\0') {*dest=rxbuf[31+i];dest++;i++;}

             i=0; dest=SN;
             memset( dest,'\0',31);
             while( i<12 && rxbuf[19+i]!='\0') {*dest=rxbuf[19+i];dest++;i++;}

             dest=Manufacturer;
             memset( dest,'\0',31);
             strncpy( dest, "Incotex", 31);
             return SUCCESS;
          }
          else
          {
             EX_Error = rxbuf[2];
             return RecodeErrorKKM( &EX_Error );
          }
       }
       else
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );
       }
   }
   else
   {
      EX_Error = res;
      return RecodeErrorKKM( &EX_Error );
   }
}

int __stdcall QueryEcrDateTime( char  *pdatetime)
//////////////////////////////////////////////////////////////////////////////
// Описание:
//           Запрашивает текущие дату и время из ККМ.
// Параметры:
//          DateTime - указатель на строку получающую данные в формате
//          (dd.mm.yy hh:mm:ss)
// Возвращаемые значения:
//            SUCCESS - выполнено успешно.
//	ERR_NO_RESPONSE - ККМ не отвечает.
//            ERR_INVALID_ARG - неверный аргумент.
//            ERR_CONN_CLOSED - соединение не открыто.
//////////////////////////////////////////////////////////////////////////////
{
   unsigned char txbuf[16],rxbuf[256], *dest, *pch, ch;
   int           res,i;
   const char * term = ".. ::\0";
   EX_Error = 0;
   if( hCOM==INVALID_HANDLE_VALUE && CurrMode<0 ) return ERR_CONN_CLOSED;

   txbuf[0]=2; txbuf[1]=3;  txbuf[2]= 0;
   res = SendDataToKKM( 1, 3, &txbuf[0] );
   if( res==ENET_SUCCS )
   {
       res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
       if( res==ENET_SUCCS )
       {
          if( rxbuf[2]==0 )
          {
             pch=&rxbuf[3];  res=0;
             while(res<6)
             {
              byte D = pch[res];
              *pdatetime = '0'+(D>>4);   pdatetime++;
              *pdatetime = '0'+(D&0x0F); pdatetime++;
              *pdatetime = term[res];    pdatetime++;
              res++;
             }
             return SUCCESS;
          }
          else
          {
             EX_Error = rxbuf[2];
             return RecodeErrorKKM( &EX_Error );
          }
       }
       else
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );
       }
   }
   else
   {
      EX_Error = res;
      return RecodeErrorKKM( &EX_Error );
   }
}
/*int __stdcall QueryEcrDateTime( char  *pdatetime)
//////////////////////////////////////////////////////////////////////////////
// Описание:
//           Запрашивает текущие дату и время из ККМ.
// Параметры:
//          DateTime - указатель на строку получающую данные в формате
//          (ddmmyyyyhhmm)
// Возвращаемые значения:
//            SUCCESS - выполнено успешно.
//	ERR_NO_RESPONSE - ККМ не отвечает.
//            ERR_INVALID_ARG - неверный аргумент.
//            ERR_CONN_CLOSED - соединение не открыто.
//////////////////////////////////////////////////////////////////////////////
{
   unsigned char txbuf[16],rxbuf[256], *dest, *pch, ch;
   int           res,i;

   EX_Error = 0;
   if( hCOM==INVALID_HANDLE_VALUE && CurrMode<0 ) return ERR_CONN_CLOSED;

   txbuf[0]=2; txbuf[1]=3;  txbuf[2]= 0;
   res = SendDataToKKM( 1, 3, &txbuf[0] );
   if( res==ENET_SUCCS )
   {
       res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
       if( res==ENET_SUCCS )
       {
          if( rxbuf[2]==0 )
          {
             memset( txbuf, '\0', 16 );
             dest = &txbuf[0];  pch=&rxbuf[3];  res=0;
             while( res<3 )
             {
               if( !(res&1) )
               {
                  ch=*pch; ch=ch>>4;
                  *dest=ch+'0';
               }
               else
               {
                  ch=*pch; ch=ch&0x0F;
                  *dest=ch+'0';
                  pch++;
               }
               res++; dest++;
             }

             dest = &txbuf[6];  pch=&rxbuf[6];  res=0;
             while( res<2 )
             {
               if( !(res&1) )
               {
                  ch=*pch; ch=ch>>4;
                  *dest=ch+'0';
               }
               else
               {
                  ch=*pch; ch=ch&0x0F;
                  *dest=ch+'0';
                  pch++;
               }
               res++; dest++;
             }
             memcpy( pdatetime, txbuf, 11);
             return SUCCESS;
          }
          else
          {
             EX_Error = rxbuf[2];
             return RecodeErrorKKM( &EX_Error );
          }
       }
       else
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );
       }
   }
   else
   {
      EX_Error = res;
      return RecodeErrorKKM( &EX_Error );
   }
}
*/

int __stdcall SynchronazeDateTime(void)
//////////////////////////////////////////////////////////////////////////////
//Описание:
//         Устанавливает дату и время ККМ по часам компьютера.
//Возвращаемые значения:
//            SUCCESS - выполнено успешно.
//	ERR_NO_RESPONSE - ККМ не отвечает.
//            ERR_CONN_CLOSED - соединение не открыто.
//////////////////////////////////////////////////////////////////////////////
{
   EX_Error = EX_IAE_UNSUPPORTED_OPER_TYPE;
   return ERR_INTERNAL;
}


