﻿#ifndef  __DrvMercFR_H__
#define  __DrvMercFR_H__

#ifndef  __THE_DLL__

typedef int ( __stdcall *TConnect)(
         unsigned char  PortNum,
         unsigned short BaudRate,
         unsigned short Timeout,
         char           *psw);

typedef int ( __stdcall *TDisconnect)( void );
typedef int ( __stdcall *TGetLastDocNum)( void );

typedef int ( __stdcall *TRegisterOper)(
         int   OperNum,
         char *OperName );

typedef int ( __stdcall *TGetCurrOper)(int *OperNum);

typedef int ( __stdcall *TGetTaxNum)(int *TaxNum);

typedef int ( __stdcall *TGetTaxRate)(
         int TaxIndex,
         int *TaxVal,
         char *Name);

typedef int ( __stdcall *TOpenReceipt) (int OperType);


typedef int ( __stdcall  *TAddRecEntry) (
         double Price,            // цена товара/услуги
         int Quantity,            // количество
         int  QuantityPrec,       // положение запятой
         double Sum,              // сумма (нафига правда не понял)
         int Depart,              // отдел
         int TaxIndex,            // налоговая ставка
         int Code,                // код
         char *Name               // наименование
);

typedef int  ( __stdcall  *TAddRecAdjust) (double Sum, char *Text );

typedef int  ( __stdcall  *TAddPay) (
         int PayType,
         double SumCash,
         double SumCashless
);

typedef int  ( __stdcall *TCloseReceipt)( int flag );

typedef int  ( __stdcall *TZreport)( void );

typedef int  ( __stdcall *TXreport)( void );

typedef int  ( __stdcall *TGetExErrorCode)( void );

typedef int  ( __stdcall *TQueryEcrIdent) (
         char *ModelName,
         char *Manufacturer,
         char *FirmvareVersion 
);
typedef int  ( __stdcall *TQueryEcrIdentEx) (
         char *ModelName,
         char *Manufacturer,
         char *FirmvareVersion, 
         char *SN
);


//          DateTime - указатель на строку получающую данные в формате
//          (dd.mm.yy hh:mm:ss)
typedef int  ( __stdcall *TQueryEcrDateTime) ( char  *pdatetime);

typedef int  ( __stdcall *TSynchronazeDateTime) (void);

#endif


///////////////////////////////////////////////////////////////////////////////
//  ОСНОВНЫЕ КОДЫ ОШИБОК
///////////////////////////////////////////////////////////////////////////////
//--- нет ошибки
#define  SUCCESS                     0

//--- соединение с ККМ не закрыто
#define  ERR_CONN_OPENED             1

//--- соединение с ККМ не открыто
#define  ERR_CONN_CLOSED             2

//--- ККМ не отвечает
#define  ERR_NO_RESPONSE             3

//--- чек уже открыт
#define  ERR_REC_OPENED              4

//--- нет открытого чека
#define  ERR_REC_NOOPEN              5

//--- слишком большое число позиций чека;
#define  ERR_DOC_OVERFLOW            7

//--- неверное значение аргумента.
#define  ERR_INVALID_ARG            14

//--- ошибка операционной системы
#define  ERR_OS_ERROR               17

//--- ошибка ККМ
#define  ERR_ECR_ERROR              18

//--- внутренняя ошибка драйвера
#define  ERR_INTERNAL               20

//--- требуется провести гашение
#define  ERR_BLANKING_NEEDED        21

//--- не хватает наличных для выполнения операции
#define  ERR_TO_LITTLE_CASHES       22

//--- величина не запрограммирована
#define  ERR_VALUE_NOT_DEFINED      23

//--- неверный пароль
#define  ERR_PASSWORD_NOT_VALID     24


///////////////////////////////////////////////////////////////////////////////
//  Расширенные коды ошибок (для ERR_INVALID_ARG).
///////////////////////////////////////////////////////////////////////////////
//--- нет дополнительной информации
#define  EX_IAE_NO_ERROR                 0

//--- неверный номер порта
#define  EX_IAE_INVALID_PORT_NUM         1

//--- неверное значение скорости обмена данными
#define  EX_IAE_INVALID_BAUD_RATE        2

//--- значение скорости обмена данными не поддерживается подключенной ККМ
#define  EX_IAE_UNSUPPORTED_BAUD_RATE    3

//--- неверное значение таймаута
#define  EX_IAE_INVALID_TIMEOUT          4

//--- неверный номер оператора
#define  EX_IAE_INVALID_OPER_NUM         6

//--- неверный тип операции
#define  EX_IAE_INVALID_OPER_TYPE        8

//--- указанный тип операции не поддерживается ККМ
#define  EX_IAE_UNSUPPORTED_OPER_TYPE    9

//--- неверный вид оплаты
#define  EX_IAE_INVALID_PAY_TYPE        17

//--- вид оплаты не поддерживается подключенной ККМ
#define  EX_IAE_UNSUPPORTED_PAY_TYPE    18

//--- неверное значение суммы оплаты
#define  EX_IAE_INVALID_PAY_SUM         20

//--- неверное значение суммы позиции
#define  EX_IAE_INVALID_ENTRY_SUM       21

//--- неверный номер отдела
#define  EX_IAE_INVALID_DEPARTMENT      22

//--- неверное значение кода позиции
#define  EX_IAE_INVALID_ENTRY_CODE      23

//--- неверное значение скидки / надбавки
#define  EX_IAE_INVALID_ADJUSTMENT      24

//--- неверное значение количества
#define  EX_IAE_INVALID_QUANTITY        25

//--- неверное значение точности количества
#define  EX_IAE_INVALID_QUAN_PREC       26

//--- неверное значение индекса налоговой ставки
#define  EX_IAE_INVALID_TAX_INDEX       27

//--- слишком большая сумма позиции
#define  EX_IAE_TOTAL_OVERFLOW          28

//--- неверный номер строки клише
#define  EX_IAE_INVALID_HEADER_LINE     29

//--- неверный тип позиции
#define  EX_IAE_INVALID_ENTRY_TYPE      30


///////////////////////////////////////////////////////////////////////////////
//   Расширенные коды ошибок (для ERR_ECR_ERROR).
///////////////////////////////////////////////////////////////////////////////
//---  нет дополнительной информации
#define  EXT_EE_NO_ERROR                0

//---  закончилась чековая лента
#define  EXT_EE_END_OF_PAPER            1

//--- ошибка принтера
#define  EXT_EE_PRN_ERROR               2

#ifdef  __THE_DLL__   //=======================================================

typedef struct {
//-----------------------------------------------------------------------------
//  Допустимые значения optype:
//     0-продажа; 1-возврат; 2-внесение; 3-выплата
//     10 - скидка; 11-надбавка; 12-сумма внесения покупателем
//
//  В случае, если это сумма оплаты, внесенная покупателем, то
//     -сама сумма храниться в поле summa
//     -uidop содержит код оплаты: 0-наличными, 1-кредит
//-----------------------------------------------------------------------------

    int            optype;       // тип операции
    int            opnum;        // номер операции в чеке
    unsigned char  uidop;        //
    unsigned char  plu[3];       // код
    unsigned char  kolvo[7];     // количество ( в тысячных )
    unsigned char  summa[7];     // сумма (в сотых)
    unsigned char  tax;          // налоговая ставка
    unsigned char  depth;        // номер отдела
    char           tovname[33];  // наименование
} DocOperationData;

 #define   STX   0x02
 #define   ETX   0x03
 #define   DLE   0x10
 #define   RDY   0xC5
 #define   WAIT  0xC7
 #define   ACK   0xCA
 #define   NAK   0xC6
 #define   BUSY  0xC9
 #define   SYN   0xCC
 #define   REJ   0xC3
 #define   DISC  0xC0
 #define   RST   0xCF


 enum {
   ENET_SUCCS,          // все ОК

   //*** ошибки, общие с кассой
   ENET_CMDNOT,         // 1  команда не определена
   ENET_BADMODE,        // 2  команда недоступна в текущем режиме
   ENET_FORMAT,         // 3  неверный формат команды или данных
   ENET_BADSN,          // 4  отказ в регистрации - кассы нет в списке разрешенных
   ENET_BADTAX,         // 5  отказ в регистрации - база налогов не соответствует
   ENET_DIFFMD,         // 6  отказ в регистрации - не в том режиме

   ENET_ONLZERO,        // 7  команда мб выполнена только при закрытой смене
   ENET_DOCOPEN,        // 8  команда мб выполнена только при закрытом чеке!

   ENET_NOTFIND,        // 9  товар/услуга не найдены (on-line)
   ENET_NOTKOLV,        // 10 нет такого количества (on-line)
   ENET_ONLCEIL,        // 11 данный товар штучный!

   ENET_NOTDISCl,       // 12 Скидки не будет
   ENET_DISCREJ,        // 13 Запрет скидки с таким значением

   ENET_BADCARD,        // 14 ОТКАЗ в оплате по данной карте
   ENET_CARDOVR,        // 15 ОТКАЗ в оплате по карте - недостаточно денег

   ENET_BADPSW,         // 16 неверный пароль при доступе к режиму
   ENET_BADPLU,         // 17 неверный код товара
   ENET_JFATAL,         // 18 критическая ошибка в ЭЖ
   ENET_NEEDREG,        // 19 требуется регистрация на сервере

   ENET_PU_ERR,         // 20 ФР: ошибка принтера
   ENET_DOCOVR,         // 21 ФР: переполнение чековых регистров
   ENET_BADOPER,        // 22 ФР: недопустимая операция
   ENET_NOTAX,          // 23 ФР: требуемый налог не определен
   ENET_JROVER,         // 24 ФР: переполнение ЭЖ
   ENET_NOMONEY,        // 25 ФР: не хватает наличных
   ENET_ERDEPTH,        // 26 ФР: ошибка отдела (закрыт или неверный номер)
   ENET_REJECT,         // 27 отклонение запроса, операции

   //*** чисто комповые ошибки ***
   ENET_BADNOM,         // неверный сетевой номер (здесь не актуально)
   ENET_TX_ERR,         // ошибка передачи
   ENET_RX_ERR,         // ошибка приема
   ENET_BADCRC,         // ошибка контрольной суммы
   ENET_TIMEOUT,        // тайм-аут
   ENET_OVERSIZE,       // переполнение
   ENET_NOT_CONN        // порт не инициализирован
 };

#endif //======================================================================


/*****************************************************************************/
#endif
/*****************************************************************************/
